.\" shorthand for double quote that works everywhere.
.ds q \N'34'
.TH intel_gpu_top __appmansuffix__ __xorgversion__
.SH NAME
intel_gpu_top \- Display a top-like summary of Intel GPU usage
.SH SYNOPSIS
.nf
.B intel_gpu_top
.B intel_gpu_top [ parameters ]
.SH DESCRIPTION
.B intel_gpu_top
is a tool to display usage information of an Intel GPU.  It requires root
privilege to map the graphics device.
.SS Options
.TP
.B -s [samples per second]
number of samples to acquire per second
.TP
.B -o [output file]
collect usage statistics to [file]. If file is "-", run non-interactively
and output statistics to stdout.
.TP
.B -e ["command to profile"]
execute a command, and leave when it is finished. Note that the entire command
with all parameters should be included as one parameter.
.TP
.B -h
show usage notes
.SH EXAMPLES
.TP
intel_gpu_top -o "cairo-trace-gvim.log" -s 100 -e "cairo-perf-trace /tmp/gvim"
will run cairo-perf-trace with /tmp/gvim trace, non-interactively, saving the
statistics into cairo-trace-gvim.log file, and collecting 100 samples per
second.
.PP
Note that idle units are not
displayed, so an entirely idle GPU will only display the ring status and
header.
.SH BUGS
Some GPUs report some units as busy when they aren't, such that even when
idle and not hung, it will show up as 100% busy.
